#include "sip_solver.h"

extern SIP_S sip_s;
extern SSO Sip_Opt;
extern STATS stats;


void get_dir_intpkkt(int nx, double *x, double *s, int nl, double *lag,
		      double *hss, double *jac, double *laggdx, double *laggdl,
		      double *term, double miu, double *dir);
void armijo_intpkkt(int nx, double *x0, double *s0, int nl, double *lag0,
		     double *dir, double miu, double *x1, double *s1,
		     double *lag1);
double intpkkt_merit(int nx, double *x0, double *s0, int nl, double *lag0,
		      double miu, double beta, double *gradx, double *grads);
double lagintpkkt(int nx, double *x, int nl, double *lag, double *s, int nt,
		  double *t, double miu, int dlevel, double *laggdx,
		  double *laggdl, double *jac, double *term, double *f);




extern int pf_eps_stop(int nx, double *x0, double *x1);
extern void set_hss(double *hss, int k, int nx , double *x1, double *x0,
	     double *g1, double *g0);
extern void identity(double *h, int nx);
extern void set_h(double *h, int k, int nx, double *x1, double *x0,
		  double *g1, double *g0);
extern int pf_i_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern int pf_o_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern void scale_dir(int nx, double *dir);
extern void egpp(int n, double *a, double *b, double *x, int *singular);
extern double gxtteo(double *x, double *t, int j, int dlevel, double *grad,
		     double miu);

extern void printarray(double *a, int n);
extern void printmatrix(double *a, int n1, int n2);
