#include "sip_solver.h"

extern SIP_S sip_s;
extern SSO Sip_Opt;

extern double penaltyf(int nx, double *x, int nt, double *t, double miu, double *pt,
		int dlevel, double *grad);
extern void gpenaltyf(int nx, double *x, int nt, double *t, double miu, double *dx, double *fx, double *pt);
extern int pf_o_stop(int nx, double *x0, double *x1, double *g1, double pt);

extern void printarray(double *a, int n);
extern void printmatrix(double *a, int n1, int n2);

extern void npoptn_(char *, int);
extern int npsol_(long *n, long *nclin, long *ncnln, long *nrowa,
        long *nrowuj, long *nrowr, double *a, double *bl, double *bu,
        void (*confun) (), void (*objfun) (), long *inform, long *iter,
        long *istate, double *c, double *ujac, double *clamda, double *objf,
        double *ugrad, double *r, double *x, long *iw, long *leniw,
        double *w, long *lenw);

void npsol_solve_pf(double *x1);
