#include "solver.h"

extern SIP_S sip_s;
extern SSO Sip_Opt;
extern STATS stats;


extern double gxt(double *x, double *t, int j, int dlevel, double *grad, double miu);
extern double gxtplus(double *x, double *t, int j, int dlevel, double *grad,
	       double miu);
extern double gxtplus2(double *x, double *t, int j, int dlevel, double *grad,
		double miu);
extern double gxtepsilon(double *x, double *t, int j, int dlevel, double *grad,
		  double miu);
extern double gxtexpplus(double *x, double *t, int j, int dlevel, double *grad,
		  double miu);
extern double gxtexpepsilon(double *x, double *t, int j, int dlevel, double *grad,
		     double miu);
extern double gxtteo(double *x, double *t, int j, int dlevel, double *grad,
	      double miu);
extern double gxtexpteo(double *x, double *t, int j, int dlevel, double *grad,
		 double miu);
extern double gxthart(double *x, double *t, int j, int dlevel, double *grad,
	       double miu);
extern double gxtgross(double *x, double *t, int j, int dlevel, double *grad,
		double miu);

extern double penaltyf(int nx, double *x, int nt, double *t, double miu, double *pt,
		int dlevel, double *grad);
extern void gpenaltyf(int nx, double *x, int nt, double *t, double miu, double *dx, double *fx, double *pt);
extern void set_h(double *h, int k, int nx, double *x1, double *x0, double *g1, double *g0);
extern void get_dir(int nx, double *x, double *h, double *grad, double *dir);
extern int pf_i_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern int pf_o_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern void scale_dir(int nx, double *dir);
extern void armijo(int nx, double *x0, double *dir, double *x1, double *grad,
	    double miu);
extern void argo(int nx, double *x0, double *dir, double *x1, double *grad,
	  double miu);
extern void wolfe(int nx, double *x0, double *dir, double *x1, double *grad,
	   double miu);


extern void printarray(double *a, int n);
extern void printmatrix(double *a, int n1, int n2);

extern void npoptn_(char *, int);
extern int npsol_(long *n, long *nclin, long *ncnln, long *nrowa,
        long *nrowuj, long *nrowr, double *a, double *bl, double *bu,
        void (*confun) (), void (*objfun) (), long *inform, long *iter,
        long *istate, double *c, double *ujac, double *clamda, double *objf,
        double *ugrad, double *r, double *x, long *iw, long *leniw,
        double *w, long *lenw);
