
#ifndef NO_DERIV
  /* no derivatives */
#define NO_DERIV 0
  /* first derivatives */
#define FIRST_DERIV 1
#endif


void gaussian(double (*gt) (), double *lb, double *ub, int nx, double *x,
	      int nt, double *t, int j, int degree, double *integral,
	      double *isgn, int dlevel, double *grad, double miu);
void trapezoid(double (*gt) (), double *lb, double *ub, int nx, double *x,
	       int nt, double *t, int degree, int j, double *integral,
	       double *isgn, int dlevel, double *grad, double miu);
void adapt_trap(double (*gt) (), double *lb, double *ub, int nx, double *x,
		int nt, double *t, int degree, int j, double *integral,
		double *isgn, double error, double amp, int dlevel,
		double *grad, double miu);
double adapt_trap2(double (*gt) (), double lb, double ub, double fl, double fu,
		   int nx, double *x, int nt, double *t, int j, double error,
		   double amp, double *isgnval, int dlevel, double *gl,
		   double *gu, double *grad, double miu);
void adapt_gauss(double (*gt) (), double *lb, double *ub, int nx, double *x,
		 int nt, double *t, int degree, int j, double *integral,
		 double *isgn, double error, double amp, int dlevel,
		 double *grad, double miu);

