#include "sip_solver.h"

extern SIP_S sip_s;
extern SSO Sip_Opt;
extern STATS stats;

double gxt(double *x, double *t, int j);
double gxtplus(double *x, double *t, int j);
double gxtepsilon(double *x, double *t, int j);
extern double penaltyf(int nx, double *x, int nt, double *t, double miu, double *pt);


void powell(double *init, double miu, int *tki);
double quad(double *xk0, double fxk0, double *dir, double *xk1, double kquasi,
	    double *h, double miu, double factor);
double poli2(double alpha1, double alpha2, double phi1, double phi2,
	     double phi3);
int pfpowell_o_stop(int nx, double *x0, double *x1);



extern void printarray(double *a, int n);
extern void printmatrix(double *a, int n1, int n2);
extern void identity(double *h, int nx);
