#include <stdlib.h>

#define USE_PRIMOS 4

int primos[]={2, 3, 5, 7, 11, 13, 17, 19, 23, 31};
int deltas[]={1, 1, 1, 1, 1, 1, 1, 1, 1, 1};

div_t divisores;

double halton(int i, int k)
{
  double hval;
  int potencia, base, j;
  
  hval=0;
  base=primos[i+USE_PRIMOS];
  potencia=1;
  for(j=1;j<=15;j++){
    divisores=div(k*deltas[i]/potencia, base);
    potencia=potencia*base;    
    hval=hval+(double)(divisores.rem)/potencia;
  }
  return hval;
}

/*
main()
{
  int i,n;
  double x[2];
  double scale;

  scale=100;
  for(n=0;n<100;n++){
    for(i=0;i<2;i++)
      x[i]=halton(i,n)*scale;
    printf("x=%f,%f\n",x[0], x[1]);
  }

}
*/
